# Retrieve usage

Use the **getSubscriptionUsages** method SOAP API 6.0 to filter and retrieve usages for a subscription.

## Request parameters

| Parameters                | Type     | Required | Description                                                                                                                    |
| ------------------------- | -------- | -------- | ------------------------------------------------------------------------------------------------------------------------------ |
| **merchantCode**          | String   | Required | String. The system-generated merchant ID.                                                                                      |
| **hash**                  | String   | Required | String. The MD5 hmac key for the request.                                                                                      |
| **sessionID**             | String   | Required | String. The system-generated code of the session.                                                                              |
| **SubscriptionReference** | String   | Required | String. The system-generated reference code of the subscription.                                                               |
| **Page**                  | Number   | Required | Number. Page to be retrieved.                                                                                                  |
| **Limit**                 | Number   | Required | Number. The number of results per page.                                                                                        |
| **IntervalStart**         | Datetime | Required | Date. Filters all usages with UsageEnd >= IntervalStart. Format "YYYY-MM-DD". The timezone used is the one on the server.      |
| **IntervalEnd**           | Datetime | Required | Date. Filters all usages with UsageEnd <= IntervalEnd. Format "YYYY-MM-DD". The timezone used is the one on the server.        |
| **RenewalOrderReference** | Number   | Optional | Number. The reference code generated by the system when the subscription is renewed.                                           |
| **OptionCode**            | String   | Optional | Unique 2Checkout option code. The pay-per-usage price options group for which the usage is uploaded. Example: metered pricing. |

### Request sample

```php
<?php
require ('PATH_TO_AUTH'); // authentication call
$subscriptionReference = 'EF4B51535B';
$usageReference = 120010492176;

try {
    $subscriptionUsageRequest = new stdClass();
    $subscriptionUsageRequest->SubscriptionReference = $subscriptionReference;
    $subscriptionUsageRequest->Page = 1;
    $subscriptionUsageRequest->Limit = 10;
    $subscriptionUsageRequest->IntervalStart = '2020-04-09 16:40:00';
    $subscriptionUsageRequest->IntervalEnd = '2020-04-12 15:40:00';
    $response = $client->getSubscriptionUsages($sessionID, $subscriptionUsageRequest);
    var_dump($response);
} catch (SoapFault $ex) {
    $faultname = (isset($ex->faultname)) ? " $faultname" : '';
    echo "[$ex->faultcode]$faultname: $ex->faultstring" . PHP_EOL;
}

exit;
```

## Response

The **getUsages** method via SOAP APIv6 returns the **Usage** object when successful.

```php
class stdClass#3 (2) {
      public $Items =>
      array(1) {
        [0] =>
        array(8) {
          'UsageReference' =>
          string(12) "120011114371"
          'SubscriptionReference' =>
          string(10) "67F3AD6A32"
          'OptionCode' =>
          string(6) "USG_MN"
          'UsageStart' =>
          string(19) "2020-07-06 12:00:00"
          'UsageEnd' =>
          string(19) "2020-07-07 12:00:00"
          'Units' =>
          int(7)
          'Description' =>
          string(15) "Response sample"
          'RenewalOrderReference' =>
          int(0)
        }
      }
      public $Pagination =>
      class stdClass#4 (3) {
        public $Page =>
        int(1)
        public $Limit =>
        int(10)
        public $Count =>
        int(1)
      }
    }
```

## Error handling

The below errors are returned when the getUsages method via SOAP APIv6 is unsuccessful.

| Error message description                                     | Error code                 | Error message                                                                  |
| ------------------------------------------------------------- | -------------------------- | ------------------------------------------------------------------------------ |
| **The provided parameters lack the required type or format.** | SEARCH\_PAGE\_INVALID      | The Page parameter must be a positive integer higher than or equal to 1.       |
|                                                               | SEARCH\_LIMIT\_INVALID     | The Limit parameter must be a positive integer lower than 100.                 |
|                                                               | MANDATORY\_FIELDS\_MISSING | Both 'IntervalStart' and 'IntervalEnd' parameters must be provided.            |
|                                                               | FILTER\_INVALID            | If provided, 'RenewalOrderReference' must be a positive integer.               |
|                                                               | FILTER\_INVALID            | 'IntervalStart' must be provided in the following format: YYYY-MM-DD HH:MM:SS. |
|                                                               | FILTER\_INVALID            | 'IntervalStart' must be provided in the following format: YYYY-MM-DD HH:MM:SS. |
|                                                               | FILTER\_INVALID            | 'IntervalEnd' must be provided in the following format: YYYY-MM-DD HH:MM:SS.   |
|                                                               | FILTER\_INVALID            | 'IntervalEnd' must be provided in the following format: YYYY-MM-DD HH:MM:SS.   |
|                                                               | SEARCH\_PAGE\_INVALID      | The Page parameter must be a positive integer higher than or equal to 1.       |
|                                                               | SUBSCRIPTION\_NOT\_FOUND   | Subscription not found.                                                        |
| **Unexpected error happens**                                  | INTERNAL\_ERROR            | \<unexpected\_error>                                                           |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/usage-management/retrieve-usage.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
